#include <stdio.h>
#include <stdlib.h>

/* 0 0000  4 0100  8 1000  C 1100
 * 1 0001  5 0101  9 1001  D 1101
 * 2 0010  6 0110  A 1010  E 1110
 * 3 0011  7 0111  B 1011  F 1111
 */

wchar_t *decode_UTF8(wchar_t *ws, char *utf8s)
{
    wchar_t     *wc;

    wc = ws;
    while(*utf8s) {
        if(!(*utf8s & 0x80)) {              /* 1 octet */
            *wc = *utf8s++;
        }
        else if((*utf8s & 0xE0) == 0xC0) {  /* 2 octets */
            *wc =  (*utf8s++ & 0x1F) << 6;
            *wc |=  *utf8s++ & 0x3F;
        }
        else if((*utf8s & 0xF0) == 0xE0) {  /* 3 octets */
            /* NOT TESTED !!! */
            *wc =  (*utf8s++ & 0x0F) << 12;
            *wc |= (*utf8s++ & 0x3F) << 6;
            *wc |=  *utf8s++ & 0x3F;
        }
        else if((*utf8s * 0xF8) == 0xF0) {  /* 4 octets */
            /* NOT TESTED !!! */
            *wc =  (*utf8s++ & 0x07) << 18;
            *wc |= (*utf8s++ & 0x3F) << 12;
            *wc |= (*utf8s++ & 0x3F) << 6;
            *wc |=  *utf8s++ & 0x3F;
        }
        ++wc;
    }
    *wc = 0;
    return ws;
}

#ifdef SELF_EXE

#include <windows.h>

void main()
{
    wchar_t     wbuf[512], *wc;
    char        buf[1024];

    printf("GetACP(): %u\n", GetACP());
    printf("GetOEMCP(): %u\n", GetOEMCP());
    printf("GetSystemDefaultLCID(): %X\n", GetSystemDefaultLCID());
    GetLocaleInfo(GetSystemDefaultLCID(), LOCALE_SENGLANGUAGE, buf, sizeof(buf));
    printf("English name of language (%X): %s\n", GetSystemDefaultLCID(), buf);
    GetLocaleInfo(MAKELANGID(LANG_GERMAN, SUBLANG_GERMAN), LOCALE_SENGLANGUAGE, buf, sizeof(buf));
    printf("English name of language (%X): %s\n", MAKELANGID(LANG_GERMAN, SUBLANG_GERMAN), buf);

    decode_UTF8(wbuf,
            "This is UTF-8 label: \"\xEF\xBB\xBF\"\n"
            "Name=\"Русский\"\n"
            "[Translation]\n"
            "; General strings\n"
            "32869=\"Невозможно подключиться к удаленному серверу\"\n"
            "32871=\"Удаленный сервер не найден.\"");
    WideCharToMultiByte(CP_OEMCP, 0, wbuf, -1, buf, sizeof(buf), NULL, NULL);
    printf("---\n%s\n", buf);

    decode_UTF8(wbuf,
        "/Терра Принт/Техническая поддержка/00200000.gif\n"
        "/ШЗТМ - печатно-позолотный пресс/bpz40000.jpg");
    WideCharToMultiByte(CP_OEMCP, 0, wbuf, -1, buf, sizeof(buf), NULL, NULL);
    printf("---\n%s\n", buf);

    wcstombs(buf, wbuf, wcslen(wbuf));
    printf("---\n%s\n", buf);
}

#endif
